# b-211.py - v 0.3 (du 25/07/2016)
#---------------------------------------------------------
from Tkinter import *
from tkMessageBox import *
from tkFileDialog import *
from scrolledtext import *
from plugs_manage import *
import string
import random
import platform
import os
import subprocess
import cl_b211
import convkeyb
NOMBRE="123456789"
#---------------------------------------------------------
def dessine_touche( lettre,chiffre, cle, coord ):
    x = coord[0] 
    y = coord[1]
    item1 = ecran.create_oval( x,y,x+30,y+30,tags=cle,fill="white")
    item2 = ecran.create_text(x+15,y+10,text=chiffre,
        font=('courrier',7,'bold'),fill='red')
    item2 = ecran.create_text(x+15,y+15,text="\n"+lettre,
        font=('courrier',7,'bold'),fill='black')
    if len(lettre) == 1 and lettre != " " :
        clavier_rond[lettre] = item1
        clavier_text[lettre] = item2
    if len(chiffre) == 1 and chiffre != " " :
        clavier_rond[chiffre] = item1
        clavier_text[chiffre] = item2
    clavier_rond[cle] = item1
    clavier_text[cle] = item2
	
    ecran.tag_bind(item1,'<Button-1>',onClic)
    ecran.tag_bind(item1,'<ButtonRelease-1>',onClicRelease)
#---------------------------------------------------------

#---------------------------------------------------------
def dessine_bouton( lettre, coord , hauteur ):
    x = coord[0] ; 
    y = coord[1]
    item = ecran.create_rectangle(x,y,x+15,y+hauteur,
        tags=lettre,fill="gold")
    ecran.tag_bind(item,'<Button-1>',onClicButton)
#---------------------------------------------------------
def onClicButton(evt):
    global cpt
    if mode_ar == "3": return
    ref = evt.widget.find_closest(evt.x, evt.y)
    tags = ecran.gettags(ref[0])
    if   tags[0] == "A":
        cpt = cpt - 1
        c.goBack()
        majAffichage()
    elif tags[0] == "I":
        cpt = cpt + 1
        c.advance()
        majAffichage()
    elif tags[0] == "B":
        c.w[0].turnClockwise()
        cleWheel[0].configure(text=c.w[0].getExternalKey())        
    elif tags[0] == "C":
        c.w[1].turnClockwise()
        cleWheel[1].configure(text=c.w[1].getExternalKey())        
    elif tags[0] == "D":
        c.w[2].turnClockwise()
        cleWheel[2].configure(text=c.w[2].getExternalKey())        
    elif tags[0] == "E":
        c.w[3].turnClockwise()
        cleWheel[3].configure(text=c.w[3].getExternalKey())        
    elif tags[0] == "F":
        c.rot_vow.advance()
        cleHRgauche.configure(text=c.rot_vow.getKey())
    elif tags[0] == "G":
        c.rot_con.advance()
        cleHRdroite.configure(text=c.rot_con.getKey())
    elif tags[0] == "J":
        c.surchi[0].advance()
        cleSurch[0].configure(text=c.surchi[0].getKey())
    elif tags[0] == "K":
        c.surchi[1].advance()
        cleSurch[1].configure(text=c.surchi[1].getKey())
    elif tags[0] == "L":
        c.surchi[2].advance()
        cleSurch[2].configure(text=c.surchi[2].getKey())
    elif tags[0] == "M":
        c.surchi[3].advance()
        cleSurch[3].configure(text=c.surchi[3].getKey())
    print "BOUTON",tags[0]
#---------------------------------------------------------
def modeChiffre():
    global mode_cd
    newMode_lt("LETTERS")
    m = modecd.cget('text')
    if m == "C":
        mode_cd = "D"
        modecd.configure(text="D")
    elif m == "D":
        mode_cd = "O"
        modecd.configure(text="O")
    elif m == "O":
        mode_cd = "C"
        modecd.configure(text="C")
    print m
#---------------------------------------------------------
def modeAvant():
    global mode_ar
    m = modear.cget('text')
    if m == "3":
        mode_ar = "1"
        modear.configure(text="1")
    else:
        mode_ar = "3"
        modear.configure(text="3")
    print "bouton AR:",m
#---------------------------------------------------------
def touche_enfoncee(lettre):
    if lettre == ' ':
        mode = c.getMode_lt()
        if mode == 'LETTERS': lettre = 'K'
        else: lettre = 'Q'
    if lettre not in alphabet : return
    item = clavier_rond[lettre]
    ecran.itemconfig(item,fill='black')
    if lettre not in dico: return
    lettre = dico[lettre]
    chiffre(lettre)
#---------------------------------------------------------
def touche_relachee(lettre):
    if lettre == ' ':
        mode = c.getMode_lt()
        if mode == 'LETTERS': lettre = 'K'
        else: lettre = 'Q'
    if lettre not in alphabet : return
    item = clavier_rond[lettre]
    ecran.itemconfig(item,fill='white')
#---------------------------------------------------------
#---------------------------------------------------------
def onKeyPress(evt):
    global une_touche_enfoncee
    if une_touche_enfoncee: return
    une_touche_enfoncee = 1
    lettre = evt.char.upper()
    for une_lettre in list(alphabet):
        if une_lettre == lettre:
            print ">>>(enfoncee)", lettre
            touche_enfoncee(lettre)
#---------------------------------------------------------
def onKeyRelease(evt):
    global une_touche_enfoncee
    une_touche_enfoncee = 0
    lettre = evt.char.upper()
    print ">>>(relachee)", lettre
    for une_lettre in list(alphabet):
        if une_lettre == lettre:
            touche_relachee(lettre)
#---------------------------------------------------------
def majAffichage():
    for i in range(4):
        cleWheel[i].configure(text=c.w[i].getExternalKey())  
        cleSurch[i].configure(text=c.surchi[i].getKey())      
    cleHRgauche.configure(text=c.rot_vow.getKey())
    cleHRdroite.configure(text=c.rot_con.getKey())
    compteur.configure(text=str("%05d" % (cpt)))
#---------------------------------------------------------
def save(nomFichier):
    global keymodified 
    if nomFichier == "":
        nomFichier = "config"
    try:
        f = open( nomFichier, "w" )
    except:
        showinfo("Error","Impossible to open file")
        print "ERROR: impossible to open file"
        return
    
    for i in range(8):
        ch = ""
        for j in range(5):
            ch += matrice_plugs[i][j]
        f.write( ch + '\n' )
         
    for i in range(4):
        ch = c.w[i].getInternalKey()
        f.write( ch + '\n' )

    f.close()

    keymodified = 0
    print "====> Sauvegarde effectuee"
#---------------------------------------------------------
def restore(nomFichier):
    try:
        f = open( nomFichier, "r" )
    except:
        if nomFichier == "conf_b21" :
            return
        showinfo("Error","Impossible to open file")
        return

    try:
        c.zero()

        for i in range(8):
            ch = f.readline()
            for j in range(5):
                matrice_plugs[i][j] = ch[j]
        [ compatible, flag ] = valide_plugs( c, matrice_plugs )
        if flag < 0: raise Exception('Incorrect format')
                
        print "===== lecture des Pins:"
        for i in range(4):
            ch = f.readline().strip()
            lg = len(ch)
            for j in range(lg):
                if ch[j] != '_':
                    c.w[i].setPinsON( ch[j] )
        maj_aff_plugs( compatible, flag )
    except:
        showinfo("Error","Impossible to read the file")
        menu_nouveau()
        return
    finally:
        f.close()

#---------------------------------------------------------
def chiffre_une(lettre):
    global cpt, textesaisie, textesaisie2, texteresultat, txtimp
    oldlettre = lettre
    oldmode = newmode = c.getMode_lt()
    if mode_ar == "1" or allumeON == 0: return
    oldletter = lettre
    if lettre in dico: lettre = dico[lettre]
    if lettre not in "ABCDEFGHIJKLMNOPQRSTUVWXYZ": return
    if mode_cd == "C":
        if (cpt % 5) == 0: majtxt(' ') ; texteresultat += ' '
        lettre_crypto = c.cipher( lettre )
        cpt = cpt + 1
        if newmode == "LETTERS" and lettre == "Z": 
            newmode = "DIGITS"
        if newmode == "DIGITS"  and lettre == "P": 
            newmode = "LETTERS"
        if oldmode != newmode : newMode_lt( newmode )
    elif mode_cd == "D":
        lettre_crypto = c.decipher( lettre ) 
        cpt = cpt + 1    
        if newmode == "LETTERS":
            indx = alpha_touches.find(lettre_crypto) 
            lettre_crypto = alpha_letters[ indx ]
            if lettre_crypto == "<":
                newMode_lt("DIGITS")
                return
        if newmode == "DIGITS":
            indx = alpha_touches.find(lettre_crypto)
            lettre_crypto = alpha_ciphers[ indx ]
            if lettre_crypto == ">":
                newMode_lt("LETTERS")
                return  
    elif mode_cd == "O":
        [lettre_crypto,newmode] = c.printl( lettre )
        if lettre == 'Z': print "?????", lettre, lettre_crypto, newmode
        if oldmode != newmode : newMode_lt( newmode ); return
    print "++++(chiffre)", lettre, lettre_crypto, newmode
    if mode_cd == "C":
        #print ">>> ", lettre, cB211.conv(lettre)
        textesaisie += cB211.unconv( lettre) 
    else:
        textesaisie += oldlettre
    textesaisie2 += lettre
    texteresultat += lettre_crypto
    majtxt( lettre_crypto)


def newMode_lt(newmode):
    oldmode = c.getMode_lt()
    if newmode == oldmode: return
    if newmode == "DIGITS": 
       ecran.move( modeletchi, 0,  30)
       #modeletchi.configure(bg='white')
    if newmode == "LETTERS":
       ecran.move( modeletchi, 0, -30)
       #modeletchi.configure(bg='black')
    c.setMode_lt(newmode)
    
def chiffre(lettre):
    if mode_ar == "1" or allumeON == 0: return
    chiffre_une(lettre)
    majAffichage()
#---------------------------------------------------------
def onClic(evt):
    ref = evt.widget.find_closest(evt.x, evt.y)
    tags = ecran.gettags(ref[0])
    touche_enfoncee(tags[0])
#---------------------------------------------------------
def onClicRelease(evt):
    ref = evt.widget.find_closest(evt.x, evt.y)
    tags = ecran.gettags(ref[0])
    touche_relachee(tags[0])    
#---------------------------------------------------------
def lcopier(lab):
    lab.clipboard_clear()
    lab.clipboard_append(lab.cget('text'))
#---------------------------------------------------------
def ok_pins():
    global lesPins, win, keymodified
    for i in range(4):
        for j in range( len(lesPins[i]) ):
            relief = lesPins[i][j].cget('relief')
            lettre = lesPins[i][j].cget('text')
            if relief == 'flat':
                c.w[i].setPinsON( lettre)
            else:
                c.w[i].setPinsOFF(lettre)
    keymodified = 1
    win.destroy()

#---------------------------------------------------------
def menu_interne_pins():
    global lesPins, win
    win = Toplevel(top)
    win.title('Setting Pins')
    aff  = []
    for i in range(4):
        aff.append( c.w[i].alphabet )
    lesPins = []
    for i in range(4):
        lesPins.append( [] )
        for j in range( len( aff[i] ) ):
            indice = i*100 + j
            aPins = c.w[i].getAPins(aff[i][j])
            if aPins:
                leRelief = 'flat'
            else:
                leRelief = 'sunken'
            l = Label(win, text=aff[i][j], relief= leRelief, \
                font=('Courier'))
            l.grid(row=i, column=j, sticky=NSEW)
            l.bind('<ButtonRelease>', reflexe_pins )
            lesPins[i].append( l )
    Button(win, text='  OK  ', command=ok_pins).grid(columnspan=10, \
        sticky=W)

#---------------------------------------------------------
def reflexe_pins(evt):
    relief = (evt.widget).cget('relief')
    if relief == 'flat':
        (evt.widget).configure(relief='sunken')
    else:
        (evt.widget).configure(relief='flat')
#---------------------------------------------------------
def init_plugs():
    alphaC = c.plug_con.alpha
    plugboardC = c.plug_con.plugboard
    alphaV = c.plug_vow.alpha
    plugboardV = c.plug_vow.plugboard
    alphaC2 = c.plug_con2.alpha
    plugboardC2 = c.plug_con2.plugboard
    alphaV2 = c.plug_vow2.alpha
    plugboardV2 = c.plug_vow2.plugboard

    for i in range(8):
        for j in range(5):
            if i == 0 or i == 2 or i == 4 or i == 6:
                matrice_plugs[i][j] = ' '
            if i == 1:
                matrice_plugs[i][j] = alphaC[  plugboardC[j] ]
            if i == 3:
                matrice_plugs[i][j] = alphaC2[ plugboardC2[j]]
            if i == 5:
                matrice_plugs[i][j] = alphaV[  plugboardV[j] ]
            if i == 7:
                matrice_plugs[i][j] = alphaV2[ plugboardV2[j]]
    maj_aff_plugs( 0, 0 )
#---------------------------------------------------------
def menu_interne_plugs():
    global win3, lesPlugsC, lesPlugsV,alphaC
    win3 = Toplevel(top)
    win3.title('Setting Plugs')
    
    lesPlugsC = []
    for i in range(8):
        lesPlugsC.append( [] )
        l = Label(win3, text='  ', font=('Courier'))
        l.grid(row=i, column=0, sticky=NSEW)
        for j in range(5):
            leText = ' ' + matrice_plugs[i][j] + ' '
            if leText == '   ':
                leRelief = 'sunken'
            else:
                leRelief = 'ridge'
            if i == 0 or i == 2 or i == 4 or i == 6: coul = 'grey'
            if i == 1 : coul = 'white'
            if i == 3 : coul = 'yellow'
            if i == 5 : coul = 'red'
            if i == 7 : coul = 'green'
            l = Label(win3, text=leText, relief=leRelief, font=('Courier'), bg=coul)
            l.grid(row=i, column=j+1, sticky=NSEW)
            l.bind('<ButtonRelease>', reflexe_plug)
            lesPlugsC[i].append( l )
    Button(win3,text=' OK ',command=ok_plugs).grid( \
        columnspan=10, row=9, sticky=W)

#---------------------------------------------------------
def ok_plugs():
    global lesPlugsC, lesPlugsV, win3, keymodified, compatible

    # --- memorise input in array matrice_plugs
    for i in range(8):
        for j in range(5):
             matrice_plugs[i][j] = lesPlugsC[i][j].cget('text')[1]
    [ compatible, flag ] = valide_plugs( c, matrice_plugs )

    if flag < 0 :
        showinfo("WARNING!", "All plugs must be plugded" + \
                 "\nand a plug must be plugged on his own plugboard")
        win3.focus_set()
    else:
        print c.plug_con.plugboard, c.plug_vow.plugboard, 
        print c.plug_con2.plugboard, c.plug_vow2.plugboard, 
        print "compatible:",compatible, "flag (crossed):",flag
        keymodified = 1
        maj_aff_plugs( compatible , flag )
        win3.destroy()

#---------------------------------------------------------
def reset_plugs():
    menu_reset_plugs()
    win3.destroy()
#---------------------------------------------------------
def maj_aff_plugs( compatible, flag ):
    if compatible:
        mode_compatible.set(1)
    else:
        mode_compatible.set(0)
    if flag == 2 or flag == 6:
        mode_crossed.set(1)
    else:
        mode_crossed.set(0)
    if flag == 4 or flag == 6:
        mode_crossed2.set(1)
    else:
        mode_crossed2.set(0)
#---------------------------------------------------------
def reflexe_plug(evt):
    global lePlug
    relief = (evt.widget).cget('relief')
    if relief == 'ridge':
        if lePlug == "":
            lePlug = (evt.widget).cget('text')[1]
            print ">>>", lePlug
            (evt.widget).configure(relief='sunken', text='   ')
    else:
        if lePlug != "":
            (evt.widget).configure(relief='ridge', text=' '+lePlug+' ')
            lePlug = ""
#---------------------------------------------------------
def menu_reset_plugs():
    c.plug_con.zero()
    c.plug_vow.zero()
    c.plug_con2.zero()
    c.plug_vow2.zero()
    init_plugs()

#---------------------------------------------------------
def compteurZ():
    global cpt
    cpt = 0
    majAffichage() 
#---------------------------------------------------------
def allume():
    global allumeON
    if allumeON == 0:
        bON_OFF.configure(bg='black')
        allumeON = 1
    else:
        bON_OFF.configure(bg='white')
        allumeON = 0  
#---------------------------------------------------------
def menu_nouveau():
    global cpt
    c.zero()
    cpt = 0
    menu_detache()
    init_plugs()
    majAffichage()

#---------------------------------------------------------
def menu_ouvrir():
    nomFichier = askopenfilename(defaultextension=".key", filetypes=\
        [('Key file','.key')])
    if ( nomFichier == ""): return
    if ( nomFichier != None ):
        restore(nomFichier) 

#---------------------------------------------------------
def menu_sauver():
    if nomFichier != None:
        save(nomFichier)
    else:
        menu_sauve_comme()

#---------------------------------------------------------
def menu_sauve_comme():
    global nomFichier
    nomFichier = asksaveasfilename(defaultextension=".key", filetypes=\
        [('Key file','.key')])
    if ( nomFichier == ""): return
    if ( nomFichier != None ):
        save(nomFichier)

#---------------------------------------------------------
def menu_quit():
    if keymodified:
        ch = askokcancel('Quit',"Are you sure (the configuration was modified) ?")
        if ch:
            sys.exit(0)
        else:
            return
    sys.exit(0)

#---------------------------------------------------------
def menu_newkey():
    ch = c.plug_vow.getAlpha()
    lst = list(ch)
    random.shuffle(lst)
    ch = "".join(lst)
    c.plug_vow.setAllPlugsLet( ch )

    ch = c.plug_con.getAlpha()
    lst = list(ch)
    random.shuffle(lst)
    ch = "".join(lst)
    c.plug_con.setAllPlugsLet( ch )

    ch = c.plug_vow2.getAlpha()
    lst = list(ch)
    random.shuffle(lst)
    ch = "".join(lst)
    c.plug_vow2.setAllPlugsLet( ch )

    ch = c.plug_con2.getAlpha()
    lst = list(ch)
    random.shuffle(lst)
    ch = "".join(lst)
    c.plug_con2.setAllPlugsLet( ch )

    init_plugs()
    for i in range(4):
        alpha = c.w[i].alphabet
        for j in range(len(alpha)):
            if random.randint(0,1):
                c.w[i].setPinsON(alpha[j])
            else:
                c.w[i].setPinsOFF(alpha[j])

#---------------------------------------------------------
def menu_printkey():
    ch = ""
    ch += c.plug_vow.getAllPlugs() + ":"
    ch += c.plug_con.getAllPlugs() 
    if c.getCompatibleMode(): ch += " Mode M1"
    ch += "\n"
    ch += c.plug_vow2.getAllPlugs()+ ":"
    ch += c.plug_con2.getAllPlugs()
    if c.getCrossedMode():    ch += " Cross"
    if c.getCrossed2Mode():   ch += " C2"
    ch += "\n"
    for i in range(4):
        ch += c.w[i].getInternalKey() + "\n"
    win = Toplevel(top)
    win.title('Printable Key')
    l = Label(win, text=ch, font=('Courier'), bg='wheat', justify='left')
    l.pack()
    Button(win, text='Copy to clipboard', command=lambda lab=l: \
        lcopier(lab)).pack()

#---------------------------------------------------------
def menu_bande():
    print textesaisie2
    win2 = Toplevel(top)
    win2.title('Cipher/Decipher')
    st1 = Label(win2, text=textesaisie, bg='white', font=('Courier'))
    st1.pack()
    st2 = Label(win2, text=texteresultat, bg='white', font=('Courier'))
    st2.pack()
    Button(win2, text='copy input (top) to the clipboard', \
        command=lambda lab=st1: lcopier(lab)).pack()
    Button(win2, text='copy output (bottom) to the clipboard', \
        command=lambda lab=st2: lcopier(lab)).pack()
    win2.protocol('WM_DELETE_WINDOW', win2.destroy)

def menu_espace():
    global textesaisie, texteresultat
    textesaisie += "  "
    texteresultat += "  "

def menu_detache():
    global textesaisie, texteresultat, cpt, txtimp
    textesaisie = ""
    texteresultat = ""
    cB211.reset()
    cpt = 0
    txtimp = " "*40
    compteur.configure(text=str("%05d" % (cpt)))
    zoneimp.configure(text=txtimp)

def menu_histo():
    ch = c.getHistory()
    win = Toplevel(top)
    win.title('History')
    st = ScrolledText( parent=win, text=ch )
    win.protocol('WM_DELETE_WINDOW', win.destroy )

def menu_retour():
    global cpt
    while cpt > 0:
        cpt -= 1
        c.goBack()
    c.resetHistory()
    majAffichage()

def menu_zero():
    global cpt
    cpt = 0
    for i in range(4):
        c.surchi[i].setKey("A")
    c.rot_vow.setKey( "A" )
    c.rot_con.setKey( "A" )
    for i in range(4):
        c.w[i].setKey("A")
    c.resetHistory()
    majAffichage()

def menu_cipher():
    ch = compteur.selection_get(selection="CLIPBOARD")
    ch = ch.upper()
    if mode_cd == "D":
        alpha = c.keyboard.alpha
        for j in range(len(ch)):
            if  string.find(alpha, ch[j] ) == -1:
                continue
            chiffre_une( ch[j] )
    elif mode_cd == "C":
        cB211.reset()
        ch2 = cB211.convall( ch )
        for un_car in ch2:
            chiffre_une( un_car )
    majAffichage()

#---------------------------------------------------------
def menu_properties():
    showinfo("Information", \
            "B-211\n" +  \
            "-----------------------------------------\n" + \
            "V 0.3, JF Bouchaudy, Licence GPL         \n" + \
            "-----------------------------------------\n" + \
            "Simulator of Hagelin B-211 cipher machine\n" + \
            "-----------------------------------------\n" + \
            "Email: jfbouch@wanadoo.fr                ")
#---------------------------------------------------------
def menu_basic_key():
    basic_key  = ""
    basic_key += "   Keyboard     (black signs)(red signs)\n"
    for i in range(5):
        d = i*5 ; f = i*5 + 5
        ch = " "*20 + alpha_letters[d:f] + " "*5 + alpha_ciphers[d:f]
        basic_key += ch + "\n"
    basic_key += " "*3 + "> = Letters, < = Ciphers, ! = Degree\n\n"
    tb = [""]*17
    basic_key += "   4 rotors (super encipherment) and 2 half-rotors\n"
    for fichier in [sur_s1,sur_s2,sur_s3,sur_s4,cle_rotv,cle_rotc]:
        f = open("rotors/" + fichier + ".rot")
        i = 0
        while 1:
            ch = f.readline().strip()
            if ch == "": break
            ch = "   " + ch + "           " 
            tb[i] += ch[0:10] ; i += 1 
        f.close()
    for ch in tb:
        basic_key += ch + "\n"

    win = Toplevel(top)
    win.title('Basic Key')
    l = Label(win, text=basic_key, font=('Courier'), bg='yellow', justify='left')
    l.pack()
    Button(win, text='Copy to clipboard', command=lambda lab=l: \
        lcopier(lab)).pack()
#---------------------------------------------------------
def menu_debug():
    c.toggleDebug()
    #c.DEBUG=1
#---------------------------------------------------------
def menu_compatible():
    pass
#---------------------------------------------------------
def menu_save_histo():
    ch = askokcancel('Save histo', \
        "Do you want to copy history in the clipboard ?")
    if ch:
        top.clipboard_clear()
        top.clipboard_append( c.getHistory())
  
#---------------------------------------------------------
def menu_help():
    aide_file = "b211_help.pdf"
    if   platform.system() == "Windows":
        os.startfile( aide_file )
    elif platform.system() == "Linux":
        subprocess.call(["xdg-open", aide_file] )
    else:
        showinfo('Help',"Read the file " + aide_file)
#---------------------------------------------------------
def menu_manual():
    aide_file = "b211_manual.pdf"
    if   platform.system() == "Windows":
        os.startfile( aide_file )
    elif platform.system() == "Linux":
        subprocess.call(["xdg-open", aide_file] )
    else:
        showinfo('Help',"Read the file " + aide_file)

#---------------------------------------------------------
#---------------------------------------------------------
def majtxt(lettre):
    global txtimp
    txtimp += lettre	
    if len(txtimp) > 40:
    	txtimp = txtimp[1:]
    zoneimp.configure(text= txtimp)

def toto():
    pass

#================ Debut du programme =====================
# 0. Initialisation de la machine a chiffrer

alphaC="" ; lePlug = ""

f = open("rotors/B211.modele")
cle_rotv = f.readline().strip()
cle_rotc = f.readline().strip()
sur_s1   = f.readline().strip()
sur_s2   = f.readline().strip()
sur_s3   = f.readline().strip()
sur_s4   = f.readline().strip()
f.close()
print "<",sur_s1,">"
c = cl_b211.B_211( cle_rotv, cle_rotc, sur_s1, sur_s2, sur_s3, sur_s4, 0 )
#alphabet = c.lights_and_keys
alphabet = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+-=%,.?"/<! *$'
alpha_touches = "OPJCNHYBKLQVXDMUZFGRIASTE"
alpha_letters = "OPJCNHYB LQVXDMU<FGRIASTE"
alpha_ciphers = "->0/,93.K! ?W6\"4Z7815+=2%"
cB211 = convkeyb.CharB211()

dico = { 'O':'O','P':'P','J':'J','C':'C','N':'N',
         '-':'O','<':'P','0':'J','/':'C',',':'N',
         'H':'H','Y':'Y','B':'B','K':'K','L':'L',
         '9':'H','3':'Y','.':'B','*':'K',
         'Q':'Q','V':'V','X':'X','D':'D','M':'M',
         '!':'Q','?':'V','W':'X','6':'D','"':'M',
         'U':'U','$':'Z','F':'F','G':'G','R':'R',
         '4':'U','Z':'Z','7':'F','8':'G','1':'R',
         'I':'I','A':'A','S':'S','T':'T','E':'E',
         '5':'I','+':'A','=':'S','2':'T','%':'E',
}
mode_cd="C"
mode_ar="3"
mode_pl=False
txtimp=" " * 40
cpt = 0
textesaisie = ""
textesaisie2= ""
texteresultat = ""
keymodified =  0
compatible = 0
nomFichier = None
allumeON = 0

#---------------------------------------------------------
# 1. Initialisation des var. glob. et Creation des widgets
coord_touche = {}
clavier_rond  = {}
clavier_text  = {}
une_touche_enfoncee = 0
#lettre_crypto = 'A'

top = Tk()
ecran = Canvas(width=500,heigh=500)
photo = PhotoImage(file='b-211.gif')
ecran.create_image(250,250, image = photo )
ecran.pack(expand=YES, fill=BOTH)
mode_compatible = IntVar()
mode_compatible.set(0)
mode_crossed = IntVar()
mode_crossed.set(0)
mode_crossed2 = IntVar()
mode_crossed2.set(0)

matrice_plugs = []
for i in range(8): matrice_plugs.append([' ']*5)
init_plugs()

#---------------------------------------------------------
# 2. On dessine les touches
#a = "QWERTYUIOPASDFGHJKLXCVBNM"
#a = alphabet
#a="ABCDEFGHIJKLMNOPQRSTUVWXYZ012"
a1=[
     "Q"," ","E","R","T","Y","U","I","O","P",
     "A","S","D","F","G","H","J"," ","L",
     "Chif","Esp","X","C","V","B","N","M"," "," "
]
a2=[
     " ","Z","%","1","2","3","4","5","-"," ",
     "+","=","6","7","8","9","0","K","deg",
     " "," ","W","/","?",".",",",'"',"Let","Esp"
]
a3 = [
     "Q","Z","E","R","T","Y","U","I","O","P",
     "A","S","D","F","G","H","J","K","L",
     "$","*","X","C","V","B","N","M","<","!"
]

coord_touche = {
   0:[100,375], 1:[135,375], 2:[170,375], 3:[205,375],
   4:[240,375], 5:[275,375], 6:[310,375], 7:[345,375],
   8:[380,375], 9:[415,375],10:[125,410],11:[160,410],
  12:[195,410],13:[230,410],14:[265,410],15:[300,410],
  16:[335,410],17:[370,410],18:[405,410],19:[100,445],
  20:[135,445],21:[170,445],22:[205,445],23:[240,445],
  24:[275,445],25:[310,445],26:[345,445],27:[380,445],
  28:[415,445]
}

for i in range(len(a1)):
    dessine_touche( a1[i], a2[i], a3[i], coord_touche[i] )

#---------------------------------------------------------
# 3. On dessine les boutons

coord_bouton = {
  'A':[15,225],'B':[80,265],'C':[110,265],'D':[165,265],
  'E':[200,265],'F':[100,170],'G':[190,170], 'H':[355,125],'I':[15,200],
  'J':[90,60],'K':[130,60],'L':[170,60],'M':[210,60]
}
for x in list("BCDEFGJKLM"):
    dessine_bouton(x, coord_bouton[x],50)
dessine_bouton('A', coord_bouton['A'],25)
dessine_bouton('I', coord_bouton['I'],25)

#---------------------------------------------------------
# 4. Creer les autres elements graphiques
cleHRgauche = Label(ecran,text='A',bg='white')
cleHRdroite = Label(ecran,text='A',bg='white')
cleWheel = []
cleWheel.append( Label(ecran,text='A',bg='white') )
cleWheel.append( Label(ecran,text='A',bg='white') )
cleWheel.append( Label(ecran,text='A',bg='white') )
cleWheel.append( Label(ecran,text='A',bg='white') )
cleSurch = []
cleSurch.append( Label(ecran,text='A',bg='white') )
cleSurch.append( Label(ecran,text='A',bg='white') )
cleSurch.append( Label(ecran,text='A',bg='white') )
cleSurch.append( Label(ecran,text='A',bg='white') )
compteur = Label( ecran, text='00000', bg='black', fg='white' )
modecd =  Button( ecran, text="C", bg='grey', command=modeChiffre )
modear =  Button( ecran, text="3", bg='grey', command=modeAvant )
cptzero=  Button( ecran, text=" ", bg='black', command=compteurZ )
bON_OFF=  Button( ecran, text=" ", bg='white', command=allume )
zoneimp = Label(ecran,text='                                        ',
                bg='white',font=('courrier',10,'bold'))
modeletchi = ecran.create_rectangle(380,260,390,270, fill='black')
ecran.create_window(130,195,window=cleHRgauche)
ecran.create_window(175,195,window=cleHRdroite)
ecran.create_window( 90,290,window=cleWheel[0])
ecran.create_window(120,290,window=cleWheel[1])
ecran.create_window(175,290,window=cleWheel[2])
ecran.create_window(210,290,window=cleWheel[3])
for i in range(4):
    ecran.create_window(80+i*40,90,window=cleSurch[i])
ecran.create_window(290,240,window=compteur)
ecran.create_window(25,180,window=modecd)
ecran.create_window(25,300,window=modear)
ecran.create_window(230,350,window=zoneimp)
ecran.create_window(300,200,window=cptzero)
ecran.create_window(470,430,window=bON_OFF)


#---------------------------------------------------------
# 5. Gestion des menus
pereMenu = Menu(top)
top.config(menu=pereMenu)
file= Menu(pereMenu, tearoff=0)
file.add_command(label='New', command=menu_nouveau, underline=0)
file.add_command(label='Open',command=menu_ouvrir, underline=0)
file.add_command(label='Save', command=menu_sauver, underline=0)
file.add_command(label='Save Key File as', command=menu_sauve_comme, underline=7)
file.add_separator()
file.add_command(label='Exit', command=menu_quit, underline=0)
sett= Menu(pereMenu, tearoff=0)
sett.add_command(label='Zeroizing', command=menu_nouveau, underline=0)
sett.add_command(label='Reset Plugs', command=menu_reset_plugs, underline=0)
sett.add_separator()
sett.add_command(label='Setting key wheel pins', command=menu_interne_pins, underline=0)
sett.add_command(label='Setting key Plugs', command=menu_interne_plugs, underline=0)
sett.add_checkbutton(label='Compatibility Mode with M1', command=menu_compatible, 
    variable=mode_compatible, state=DISABLED,   underline=0)
sett.add_checkbutton(label='Crossed Mode', command=menu_compatible, 
    variable=mode_crossed, state=DISABLED,   underline=0)
sett.add_checkbutton(label='Crossed Mode 2', command=menu_compatible, 
    variable=mode_crossed2, state=DISABLED,   underline=0)
sett.add_command(label='Print internal Key', command=menu_printkey, underline=0)
sett.add_separator()
sett.add_command(label='Generate New key', command=menu_newkey, underline=0)
sett.add_command(label='Print Basic Key', command=menu_basic_key, underline=0)
affi= Menu(pereMenu, tearoff=0)
affi.add_command(label='Tapes', command=menu_bande, underline=0)
affi.add_command(label='Advance tapes', command=menu_espace, underline=0)
affi.add_command(label='Cut tapes', command=menu_detache, underline=0)
affi.add_separator()
affi.add_checkbutton(label='Debug', command=menu_debug, underline=0)
affi.add_separator()
affi.add_command(label='History', command=menu_histo, underline=0)
affi.add_command(label='Save History', command=menu_save_histo, underline=0)
extk= Menu(pereMenu, tearoff=0)
extk.add_command(label='Ready to check (AAAAAA)', command=menu_zero, underline=0)
extk.add_command(label='Come-back (Counter:0000)', command=menu_retour, underline=0)
extk.add_separator()
extk.add_command(label='To cipher from clipboard', command=menu_cipher, underline=0)
hlpm= Menu(pereMenu, tearoff=0)
hlpm.add_command(label='Help', command=menu_help, underline=0)
hlpm.add_command(label='Manual', command=menu_manual, underline=0)
hlpm.add_separator()
hlpm.add_command(label='About ...', command=menu_properties, underline=0)
pereMenu.add_cascade(label='File', menu=file, underline=0)
pereMenu.add_cascade(label='Internal Key', menu=sett, underline=0)
pereMenu.add_cascade(label='Display', menu=affi, underline=0)
pereMenu.add_cascade(label='External Key', menu=extk, underline=0)
pereMenu.add_cascade(label='?', menu=hlpm, underline=0)
top.bind("<KeyPress>", onKeyPress)
top.protocol("WM_DELETE_WINDOW",menu_quit)

#---------------------------------------------------------
# 6. Gerer les evts
top.bind("<Any-KeyPress>",onKeyPress)
top.bind("<Any-KeyRelease>",onKeyRelease)

#---------------------------------------------------------
top.mainloop()

