# cl_fract.py

import sys
import string

#========== Class Fraction
class Fraction:
    def __init__(self,alpha):
        self.alpha = alpha
        self.bili = {}
        vowel = consonant = i = 0
        for letter in list(self.alpha):
            # print letter, vowel, consonant
            self.bili[letter] = [vowel,consonant]
            consonant = ( consonant + 1) % 5
            i = i + 1
            vowel = i // 5
            
    def letter2bili(self, letter):
        return self.bili[letter]

    def bili2letter(self, vowel, consonant ):
        return self.alpha[ vowel * 5 + consonant ]

    def info(self):
        for i in range( 5 ):
            for j in range( 5 ):
                print self.alpha[ i * 5 + j ],
            print

if __name__ == "__main__":
    f = Fraction("LMYFXOJBRSPUGCWKNTDQIHVEA")

    vowel = "AEIOU"
    consonant = "LNRST"

    for letter in list("YOUR"):
        [ v, c ] = f.letter2bili( letter )
        new_letter = f.bili2letter( v, c )
        print letter, v,c, vowel[v], consonant[c], new_letter

    f.info()
